#!/bin/sh
#***************************************************************************
# ZEPTOOS:zepto-info
#      This file is part of ZeptoOS: The Small Linux for Big Computers.
#      See www.mcs.anl.gov/zeptoos for more information.
# ZEPTOOS:zepto-info
#
# ZEPTOOS:zepto-fillin
#      $Id: create_ktaud.conf.sh,v 1.7 2006/11/12 00:26:30 anataraj Exp $
#      ZeptoOS_Version: DEVELOPMENT-PRERELEASE
#      ZeptoOS_Heredity: FOSS_ORIG
#      ZeptoOS_License: GPL
# ZEPTOOS:zepto-fillin
#
# ZEPTOOS:zepto-gpl
#       Copyright: Argonne National Laboratory, Department of Energy,
#                  and University of Chicago.  2004, 2005
#       ZeptoOS License: GPL
#  
#       This software is free.  See the file ZeptoOS/misc/license.GPL
#       for complete details on your rights to copy, modify, and use this
#       software.
# ZEPTOOS:zepto-gpl
#***************************************************************************

_basedir=`dirname $0`
basedir=`cd ${_basedir}; pwd`
homedir=`cd ~;pwd`
OUTPUT=${_basedir}/ktaud.conf

#loads the toplevel configuration from the command line input
. $1

#Building ktaud.conf file
if [ "${ENABLE_KTAUD}" = "y" ];
then
	#echo "... Creating ktaud.conf"
	echo "# Automatically generated by create_ktaud.conf.sh script." > ${OUTPUT}
#-------------------------------------------------------
# Ktaud mode of operation

if [ "${KTAUD_PROFILE}" = "y" ];
then
	#echo "... Using Ktaud profiling mode"
	echo "info profile" >> ${OUTPUT}
else if [ "${KTAUD_TRACE}" = "y" ]; then
	#echo "... Using Ktaud tracing mode"
	echo "info trace" >> ${OUTPUT}
fi fi
#-------------------------------------------------------
# Ktaud sampling period

#echo "... Ktaud sampling period = ${KTAUD_SAMPLE_PERIOD}"
echo "sample_period ${KTAUD_SAMPLE_PERIOD}" >> ${OUTPUT}
#-------------------------------------------------------
# Ktaud output directory

#echo "... Ktaud output directory = ${KTAUD_OUTPUT_DIR}"
echo "output_dir ${KTAUD_OUTPUT_DIR}/" >> ${OUTPUT}
#-------------------------------------------------------
# Ktaud sampling mode

if [ "${KTAUD_SAMPLE_MODE_ALL}" = "y" ]; then
	#echo "... Ktaud sampling mode: all"
	echo "mode all" >> ${OUTPUT}
else if [ "${KTAUD_SAMPLE_MODE_SELF}" = "y" ]; then
	#echo "... Ktaud sampling mode: self"
	echo "mode self" >> ${OUTPUT}
else if [ "${KTAUD_SAMPLE_MODE_PID}" = "y" ]; then
	#echo "... Ktaud sampling mode: pid"
	echo "mode pid" >> ${OUTPUT}
	#echo "...... Ktaud pid list : ${KTAUD_PID_LIST}"
	echo "pid ${KTAUD_PID_LIST}" >> ${OUTPUT}
fi fi fi

else
	echo "... No Ktaud configuration exist."
fi
#-------------------------------------------------------
# Specifying the default directory of KTAUD_CONFIG_PATH and KTAUD_PATH
sed -e "s@^#KTAUD_CONFIG_PATH=@KTAUD_CONFIG_PATH="${KTAUD_CONFIG_PATH}"@g" < ${_basedir}/ktaud.sh.default > ${_basedir}/ktaud.sh.tmp
sed -e "s@^#KTAUD_PATH=@KTAUD_PATH="${KTAUD_PATH}"@g" < ${_basedir}/ktaud.sh.tmp > ${_basedir}/ktaud.sh
chmod 755 ${_basedir}/ktaud.sh
rm -f ${_basedir}/ktaud.sh.tmp
exit 0
